package de.unimarburg.swt.emf.metrics.birt;

import org.eclipse.jface.wizard.Wizard;

public class ReportingWizard extends Wizard {
	
	private MetricsReporter metricsReporter;
	private ReportingWizardPage page;

	public ReportingWizard(MetricsReporter metricsReporter) {
		setWindowTitle("EMF Metrics - Reporting -");
		this.metricsReporter = metricsReporter;
	}
	
	public MetricsReporter getMetricsReporter() {
		return metricsReporter;
	}

	@Override
	public void addPages() {
		page = new ReportingWizardPage(this);
		addPage(page);
	}

	@Override
	public boolean performFinish() {
		metricsReporter.setDoc(page.btnDoc.getSelection());
		metricsReporter.setHtml(page.btnHtml.getSelection());
		metricsReporter.setOdp(page.btnOdp.getSelection());
		metricsReporter.setOds(page.btnOds.getSelection());
		metricsReporter.setOdt(page.btnOdt.getSelection());
		metricsReporter.setPdf(page.btnPdf.getSelection());
		metricsReporter.setPostcript(page.btnPostcript.getSelection());
		metricsReporter.setPpt(page.btnPpt.getSelection());
		metricsReporter.setXls(page.btnXls.getSelection());
		metricsReporter.setDesignName(page.getDesign());
		metricsReporter.setFileName(page.getDestination());		
		metricsReporter.doReport();
		return true;
	}
	
	@Override
	public boolean canFinish() {
		return page.isPageComplete();
	}

}
