package de.unimarburg.swt.emf.metrics.gui.actions;

import java.util.List;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.henshin.interpreter.util.ModelHelper;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PlatformUI;

import de.unimarburg.swt.emf.metrics.EMFMetrics;
import de.unimarburg.swt.emf.metrics.utils.ProjectUtils;
import de.unimarburg.swt.emf.metrics.utils.SelectionUtils;

public class CalculateMetricsActionDelegate implements IObjectActionDelegate{

	private List<EObject> context;
	private IProject project;
	private IWorkbenchPart targetPart;
	private ISelection selection;
	
	@Override
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
		this.targetPart=targetPart;		
	}

	@Override
	public void selectionChanged(IAction action, ISelection selection) {
		if(selection instanceof IStructuredSelection)
			this.selection = (IStructuredSelection) selection;
		else 	
			this.selection = null;
	}

	@Override
	public void run(IAction action) {
		Cursor oldCursor = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell().getCursor();
		PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell().setCursor(new Cursor(null,SWT.CURSOR_WAIT));
		project = ProjectUtils.getActualProject();
		ISelection selection = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getSelectionService().getSelection();
		context = SelectionUtils.getESelection(selection);
		if(context == null){
			if(selection instanceof IStructuredSelection){
				Object o = ((IStructuredSelection)selection).getFirstElement();
				if(o instanceof IFile){
					IFile selectedFile = (IFile)o;
					project = selectedFile.getProject();
					EObject root = ModelHelper.loadFile(selectedFile.getFullPath().toString());
//					context = new LinkedList<EObject>();
//					context.addAll(getAllEObjects(root));
//					Iterator<EObject> allEObjects = root.eAllContents();
//					EObject eObject;
//					while(allEObjects.hasNext()){
//						eObject = allEObjects.next();
//						context.add(eObject);
//					}
					EMFMetrics.calculateAllConfiguredMetrics(project, root);
				}	
			}
		}else
			EMFMetrics.calculateConfiguredMetrics(project, context);
		PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell().setCursor(oldCursor);
	}
	
//	public void warten(final String text,final Runnable r) {
//        final Frame parent=null;
//        final JDialog dialog= new JDialog(parent,"warten...",true);
//        final Thread wait=new Thread() {
//            public void run() {
//                r.run();
//                dialog.setVisible(false);
//            }
//        };
//        dialog.add(new JLabel(text));
//        dialog.setSize(200,100);
////        dialog.setDefaultCloseOperation(AWT.DO_NOTHING_ON_CLOSE);
//        dialog.addWindowListener(
//            new WindowAdapter() {
//                public void windowClosing (WindowEvent event) {
//                    if (JOptionPane.showConfirmDialog(dialog,
//                        "wirklich den Vorgang abbrechen?","abbrechen?",
//                        JOptionPane.YES_NO_OPTION)==0) {
//                            wait.interrupt();
//                            dialog.setVisible(false);
//                        }
//                }
//            });
////        dialog.setLocation(
////            getLocation().x+(getSize().width-dialog.getSize().width)/2,
////            getLocation().y+(getSize().height-dialog.getSize().height)/2);
//        wait.start();
//        dialog.setVisible(true);
//    }


	
}
