package de.unimarburg.swt.emf.metrics.gui.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchPartSite;
import org.eclipse.ui.IWorkbenchWindow;

import de.unimarburg.swt.emf.metrics.gui.wizard.NewMetricWizard;


public class CreateMetricActionDelegate implements IObjectActionDelegate{

	private IWorkbenchPart targetPart;
	private IStructuredSelection selection;
	
	@Override
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
		this.targetPart=targetPart;		
	}

	@Override
	public void selectionChanged(IAction action, ISelection selection) {
		if(selection instanceof IStructuredSelection)
			this.selection = (IStructuredSelection) selection;
		else 	
			this.selection = null;
	}
		
	@Override
	public void run(IAction action) {
		IWorkbenchPartSite site = targetPart.getSite();
		IWorkbenchWindow window = site.getWorkbenchWindow();
		NewMetricWizard wizard = new NewMetricWizard();
		wizard.init(window.getWorkbench(), selection);
		WizardDialog dialog = new WizardDialog(window.getShell(), wizard);
		dialog.open();
	}
}
