package de.unimarburg.swt.emf.metrics.gui.wizard;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;

public class OCLDataWizardPage extends WizardPage implements Listener{

	private static final String PAGE_NAME = "org.eclipse.emf.metrics.wizards.OCLDataWizardPage";
	private static final String PAGE_TITLE = "OCL Expression";
	private static final String PAGE_DESCRIPTION = "Enter the OCL Expression. \n"
												+ "(required fields are denoted by \"*\")";
	
	private String oclExpression;
	
	private StyledText oclExpressionTextField;
	

	public OCLDataWizardPage(){
		super(PAGE_NAME);
		setTitle(PAGE_TITLE);
		setDescription(PAGE_DESCRIPTION);
	}
	
	@Override
	public void createControl(Composite parent) {
		Composite container = new Composite(parent, SWT.NULL);
		final GridLayout layout = new GridLayout();
		layout.numColumns = 1;
		container.setLayout(layout);
		createTextFields(container);
//		initContents();
		setControl(container);
		this.setPageComplete(false);

	}
	
	public String getOCLExpression(){
		return oclExpression;
	}
	
	private void createTextFields(Composite container) {
		Label label;
		GridData gridData;
		Group group;
		GridLayout layout;
		// - Metric Data -
		group = new Group(container, SWT.NONE);
		group.setText("Metric data");
	    layout = new GridLayout();
	    layout.numColumns = 2;
	    group.setLayout(layout);
	    gridData = new GridData(GridData.FILL_HORIZONTAL | GridData.FILL_VERTICAL);
	    group.setLayoutData(gridData);
		// - Name -
		// col:1
		label = new Label(group, SWT.NONE);
		label.setText("OCL Expression *:");
		label.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_END | GridData.VERTICAL_ALIGN_BEGINNING));
		// col:2
		oclExpressionTextField  = new StyledText(group, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL | SWT.H_SCROLL);
		//new Text(group, SWT.BORDER);
//		oclExpressionTextField.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		oclExpressionTextField.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL));
		oclExpressionTextField.addListener(SWT.Modify, this);
		oclExpressionTextField.setText("self.");
	}

	@Override
	public void handleEvent(Event event) {
		updatePageComplete();
		
	}

	private void updatePageComplete() {
		setPageComplete(!this.oclExpressionTextField.getText().isEmpty());
		saveTextFieldValues();
		
	}

	private void saveTextFieldValues() {
		String ocl = this.oclExpressionTextField.getText();
		ocl = ocl.replaceAll("\r", " ");
		ocl = ocl.replaceAll("\n", " ");
		((NewMetricWizard)getWizard()).setOCLExpression(ocl);	
	}
	
	

}
