package de.unimarburg.swt.emf.modelsmell.model.smellfinder.treeviewer;

import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;

import de.unimarburg.swt.emf.modelsmell.model.ModelSmell;

/**
 * Class holding a set of EObjects which are constituting a smell on a model.
 * 
 * @author Matthias Burhenne
 *
 */

public class EObjectGroup {
	ModelSmell smell;
	LinkedList<EObject> eObjects;
	private ModelSmellResult result;
	
	public EObjectGroup(ModelSmell smell, LinkedList<EObject> eObjects){
		this.eObjects = eObjects;
		this.smell = smell;
	}

	public LinkedList<EObject> getEObjects() {
		return eObjects;
	}
	
	public ModelSmell getModelSmell(){
		return smell;
	}

	public void setEObjects(List<EObject> eObjects) {
		LinkedList<EObject> newEObjects = new LinkedList<EObject>();
		newEObjects.addAll(eObjects);
		this.eObjects = newEObjects;
	}
	
	public ModelSmellResult getModelSmellResult(){
		return result;
	}
	
	public void setModelSmellResult(ModelSmellResult result){
		this.result = result;
	}	
}
