package de.unimarburg.swt.emf.modelsmell.views;

import java.util.LinkedList;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import de.unimarburg.swt.emf.modelsmell.model.smellfinder.treeviewer.EObjectGroup;
import de.unimarburg.swt.emf.modelsmell.model.smellfinder.treeviewer.ModelSmellResult;
import de.unimarburg.swt.emf.modelsmell.model.smellfinder.treeviewer.ResultModel;

public class ResultModelTreeViewerContentProvider implements
		ITreeContentProvider {

	private static Object[] EMPTY_ARRAY = new Object[0];
	
	@Override
	public void dispose() {
		// TODO Auto-generated method stub

	}

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		// TODO Auto-generated method stub

	}

	@Override
	public Object[] getElements(Object inputElement) {
		return getChildren(inputElement);
	}

	@Override
	public Object[] getChildren(Object parentElement) {
		if(parentElement instanceof LinkedList<?>){
			return ((LinkedList<ResultModel>) parentElement).toArray();
		}
		if(parentElement instanceof ResultModel)
			return sortModelSmellResultArray(((ResultModel)parentElement).getModelSmellResults().toArray());
		if(parentElement instanceof ModelSmellResult)
			return ((ModelSmellResult)parentElement).getEObjectGroups().toArray();
		if(parentElement instanceof EObjectGroup)
			return ((EObjectGroup)parentElement).getEObjects().toArray();
		else
			return EMPTY_ARRAY;
	}

	@Override
	public Object getParent(Object element) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean hasChildren(Object element) {
		return getChildren(element).length > 0;
	}
	
	private Object[] sortModelSmellResultArray(Object[] resultArray){
		Object[] sortedResults = resultArray;
		for(int i = 0; i < sortedResults.length; i++){
			for(int j = 0; j < sortedResults.length; j++){
				if(((ModelSmellResult) sortedResults[i]).getEObjectGroups().size() > ((ModelSmellResult) sortedResults[j]).getEObjectGroups().size()){
					ModelSmellResult temp = (ModelSmellResult) sortedResults[i];
					sortedResults[i] = sortedResults[j];
					sortedResults[j] = temp;
				}
			}
		}
		return sortedResults;
		
	}

}
