/*******************************************************************************
 * Copyright (c) Philipps University of Marburg. All rights reserved. 
 * This program and the accompanying materials are made 
 * available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Philipps University of Marburg - initial API and implementation
 *******************************************************************************/
package org.eclipse.emf.refactor.common.groupmanagement;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Emf Refactoring Entry</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getId <em>Id</em>}</li>
 *   <li>{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getMmgroup <em>Mmgroup</em>}</li>
 *   <li>{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getAlias <em>Alias</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.emf.refactor.common.groupmanagement.GroupmanagementPackage#getEmfRefactoringEntry()
 * @model
 * @generated
 */
public interface EmfRefactoringEntry extends EObject {
	/**
	 * Returns the value of the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Id</em>' attribute.
	 * @see #setId(String)
	 * @see org.eclipse.emf.refactor.common.groupmanagement.GroupmanagementPackage#getEmfRefactoringEntry_Id()
	 * @model
	 * @generated
	 */
	String getId();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getId <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Id</em>' attribute.
	 * @see #getId()
	 * @generated
	 */
	void setId(String value);

	/**
	 * Returns the value of the '<em><b>Mmgroup</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mmgroup</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mmgroup</em>' reference.
	 * @see #setMmgroup(MetaModelGroup)
	 * @see org.eclipse.emf.refactor.common.groupmanagement.GroupmanagementPackage#getEmfRefactoringEntry_Mmgroup()
	 * @model required="true"
	 * @generated
	 */
	MetaModelGroup getMmgroup();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getMmgroup <em>Mmgroup</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mmgroup</em>' reference.
	 * @see #getMmgroup()
	 * @generated
	 */
	void setMmgroup(MetaModelGroup value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.eclipse.emf.refactor.common.groupmanagement.GroupmanagementPackage#getEmfRefactoringEntry_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Alias</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Alias</em>' attribute.
	 * @see #setAlias(String)
	 * @see org.eclipse.emf.refactor.common.groupmanagement.GroupmanagementPackage#getEmfRefactoringEntry_Alias()
	 * @model
	 * @generated
	 */
	String getAlias();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getAlias <em>Alias</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Alias</em>' attribute.
	 * @see #getAlias()
	 * @generated
	 */
	void setAlias(String value);

} // EmfRefactoringEntry
