/*******************************************************************************
 * Copyright (c) Philipps University of Marburg. All rights reserved. 
 * This program and the accompanying materials are made 
 * available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Philipps University of Marburg - initial API and implementation
 *******************************************************************************/
package org.eclipse.emf.refactor.common.groupmanagement;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.emf.refactor.common.groupmanagement.GroupmanagementFactory
 * @model kind="package"
 * @generated
 */
public interface GroupmanagementPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "groupmanagement";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://groupmanagement/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "groupmanagement";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	GroupmanagementPackage eINSTANCE = org.eclipse.emf.refactor.common.groupmanagement.impl.GroupmanagementPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.emf.refactor.common.groupmanagement.impl.GroupManagementImpl <em>Group Management</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupManagementImpl
	 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupmanagementPackageImpl#getGroupManagement()
	 * @generated
	 */
	int GROUP_MANAGEMENT = 0;

	/**
	 * The feature id for the '<em><b>Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_MANAGEMENT__GROUPS = 0;

	/**
	 * The number of structural features of the '<em>Group Management</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_MANAGEMENT_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link org.eclipse.emf.refactor.common.groupmanagement.impl.GroupImpl <em>Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupImpl
	 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupmanagementPackageImpl#getGroup()
	 * @generated
	 */
	int GROUP = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP__NAME = 0;

	/**
	 * The feature id for the '<em><b>Mm Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP__MM_GROUPS = 1;

	/**
	 * The number of structural features of the '<em>Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.emf.refactor.common.groupmanagement.impl.MetaModelGroupImpl <em>Meta Model Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.MetaModelGroupImpl
	 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupmanagementPackageImpl#getMetaModelGroup()
	 * @generated
	 */
	int META_MODEL_GROUP = 2;

	/**
	 * The feature id for the '<em><b>Ns Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int META_MODEL_GROUP__NS_URI = 0;

	/**
	 * The feature id for the '<em><b>Entries</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int META_MODEL_GROUP__ENTRIES = 1;

	/**
	 * The number of structural features of the '<em>Meta Model Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int META_MODEL_GROUP_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.emf.refactor.common.groupmanagement.impl.EmfRefactoringEntryImpl <em>Emf Refactoring Entry</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.EmfRefactoringEntryImpl
	 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupmanagementPackageImpl#getEmfRefactoringEntry()
	 * @generated
	 */
	int EMF_REFACTORING_ENTRY = 3;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_REFACTORING_ENTRY__ID = 0;

	/**
	 * The feature id for the '<em><b>Mmgroup</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_REFACTORING_ENTRY__MMGROUP = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_REFACTORING_ENTRY__NAME = 2;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_REFACTORING_ENTRY__ALIAS = 3;

	/**
	 * The number of structural features of the '<em>Emf Refactoring Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EMF_REFACTORING_ENTRY_FEATURE_COUNT = 4;


	/**
	 * Returns the meta object for class '{@link org.eclipse.emf.refactor.common.groupmanagement.GroupManagement <em>Group Management</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Group Management</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.GroupManagement
	 * @generated
	 */
	EClass getGroupManagement();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.emf.refactor.common.groupmanagement.GroupManagement#getGroups <em>Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Groups</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.GroupManagement#getGroups()
	 * @see #getGroupManagement()
	 * @generated
	 */
	EReference getGroupManagement_Groups();

	/**
	 * Returns the meta object for class '{@link org.eclipse.emf.refactor.common.groupmanagement.Group <em>Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Group</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.Group
	 * @generated
	 */
	EClass getGroup();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.emf.refactor.common.groupmanagement.Group#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.Group#getName()
	 * @see #getGroup()
	 * @generated
	 */
	EAttribute getGroup_Name();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.emf.refactor.common.groupmanagement.Group#getMmGroups <em>Mm Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Mm Groups</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.Group#getMmGroups()
	 * @see #getGroup()
	 * @generated
	 */
	EReference getGroup_MmGroups();

	/**
	 * Returns the meta object for class '{@link org.eclipse.emf.refactor.common.groupmanagement.MetaModelGroup <em>Meta Model Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Meta Model Group</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.MetaModelGroup
	 * @generated
	 */
	EClass getMetaModelGroup();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.emf.refactor.common.groupmanagement.MetaModelGroup#getNsUri <em>Ns Uri</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ns Uri</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.MetaModelGroup#getNsUri()
	 * @see #getMetaModelGroup()
	 * @generated
	 */
	EAttribute getMetaModelGroup_NsUri();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.emf.refactor.common.groupmanagement.MetaModelGroup#getEntries <em>Entries</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Entries</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.MetaModelGroup#getEntries()
	 * @see #getMetaModelGroup()
	 * @generated
	 */
	EReference getMetaModelGroup_Entries();

	/**
	 * Returns the meta object for class '{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry <em>Emf Refactoring Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Emf Refactoring Entry</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry
	 * @generated
	 */
	EClass getEmfRefactoringEntry();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getId()
	 * @see #getEmfRefactoringEntry()
	 * @generated
	 */
	EAttribute getEmfRefactoringEntry_Id();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getMmgroup <em>Mmgroup</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Mmgroup</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getMmgroup()
	 * @see #getEmfRefactoringEntry()
	 * @generated
	 */
	EReference getEmfRefactoringEntry_Mmgroup();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getName()
	 * @see #getEmfRefactoringEntry()
	 * @generated
	 */
	EAttribute getEmfRefactoringEntry_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getAlias <em>Alias</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Alias</em>'.
	 * @see org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry#getAlias()
	 * @see #getEmfRefactoringEntry()
	 * @generated
	 */
	EAttribute getEmfRefactoringEntry_Alias();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	GroupmanagementFactory getGroupmanagementFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.eclipse.emf.refactor.common.groupmanagement.impl.GroupManagementImpl <em>Group Management</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupManagementImpl
		 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupmanagementPackageImpl#getGroupManagement()
		 * @generated
		 */
		EClass GROUP_MANAGEMENT = eINSTANCE.getGroupManagement();

		/**
		 * The meta object literal for the '<em><b>Groups</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GROUP_MANAGEMENT__GROUPS = eINSTANCE.getGroupManagement_Groups();

		/**
		 * The meta object literal for the '{@link org.eclipse.emf.refactor.common.groupmanagement.impl.GroupImpl <em>Group</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupImpl
		 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupmanagementPackageImpl#getGroup()
		 * @generated
		 */
		EClass GROUP = eINSTANCE.getGroup();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GROUP__NAME = eINSTANCE.getGroup_Name();

		/**
		 * The meta object literal for the '<em><b>Mm Groups</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GROUP__MM_GROUPS = eINSTANCE.getGroup_MmGroups();

		/**
		 * The meta object literal for the '{@link org.eclipse.emf.refactor.common.groupmanagement.impl.MetaModelGroupImpl <em>Meta Model Group</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.MetaModelGroupImpl
		 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupmanagementPackageImpl#getMetaModelGroup()
		 * @generated
		 */
		EClass META_MODEL_GROUP = eINSTANCE.getMetaModelGroup();

		/**
		 * The meta object literal for the '<em><b>Ns Uri</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute META_MODEL_GROUP__NS_URI = eINSTANCE.getMetaModelGroup_NsUri();

		/**
		 * The meta object literal for the '<em><b>Entries</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference META_MODEL_GROUP__ENTRIES = eINSTANCE.getMetaModelGroup_Entries();

		/**
		 * The meta object literal for the '{@link org.eclipse.emf.refactor.common.groupmanagement.impl.EmfRefactoringEntryImpl <em>Emf Refactoring Entry</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.EmfRefactoringEntryImpl
		 * @see org.eclipse.emf.refactor.common.groupmanagement.impl.GroupmanagementPackageImpl#getEmfRefactoringEntry()
		 * @generated
		 */
		EClass EMF_REFACTORING_ENTRY = eINSTANCE.getEmfRefactoringEntry();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EMF_REFACTORING_ENTRY__ID = eINSTANCE.getEmfRefactoringEntry_Id();

		/**
		 * The meta object literal for the '<em><b>Mmgroup</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EMF_REFACTORING_ENTRY__MMGROUP = eINSTANCE.getEmfRefactoringEntry_Mmgroup();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EMF_REFACTORING_ENTRY__NAME = eINSTANCE.getEmfRefactoringEntry_Name();

		/**
		 * The meta object literal for the '<em><b>Alias</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EMF_REFACTORING_ENTRY__ALIAS = eINSTANCE.getEmfRefactoringEntry_Alias();

	}

} //GroupmanagementPackage
