/*******************************************************************************
 * Copyright (c) Philipps University of Marburg. All rights reserved. 
 * This program and the accompanying materials are made 
 * available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Philipps University of Marburg - initial API and implementation
 *******************************************************************************/
package org.eclipse.emf.refactor.common.groupmanagement.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.refactor.common.groupmanagement.EmfRefactoringEntry;
import org.eclipse.emf.refactor.common.groupmanagement.GroupmanagementPackage;
import org.eclipse.emf.refactor.common.groupmanagement.MetaModelGroup;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Emf Refactoring Entry</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.emf.refactor.common.groupmanagement.impl.EmfRefactoringEntryImpl#getId <em>Id</em>}</li>
 *   <li>{@link org.eclipse.emf.refactor.common.groupmanagement.impl.EmfRefactoringEntryImpl#getMmgroup <em>Mmgroup</em>}</li>
 *   <li>{@link org.eclipse.emf.refactor.common.groupmanagement.impl.EmfRefactoringEntryImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.emf.refactor.common.groupmanagement.impl.EmfRefactoringEntryImpl#getAlias <em>Alias</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class EmfRefactoringEntryImpl extends EObjectImpl implements EmfRefactoringEntry {
	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The cached value of the '{@link #getMmgroup() <em>Mmgroup</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMmgroup()
	 * @generated
	 * @ordered
	 */
	protected MetaModelGroup mmgroup;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getAlias() <em>Alias</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlias()
	 * @generated
	 * @ordered
	 */
	protected static final String ALIAS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getAlias() <em>Alias</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlias()
	 * @generated
	 * @ordered
	 */
	protected String alias = ALIAS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EmfRefactoringEntryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return GroupmanagementPackage.Literals.EMF_REFACTORING_ENTRY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId) {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, GroupmanagementPackage.EMF_REFACTORING_ENTRY__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MetaModelGroup getMmgroup() {
		if (mmgroup != null && mmgroup.eIsProxy()) {
			InternalEObject oldMmgroup = (InternalEObject)mmgroup;
			mmgroup = (MetaModelGroup)eResolveProxy(oldMmgroup);
			if (mmgroup != oldMmgroup) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, GroupmanagementPackage.EMF_REFACTORING_ENTRY__MMGROUP, oldMmgroup, mmgroup));
			}
		}
		return mmgroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MetaModelGroup basicGetMmgroup() {
		return mmgroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMmgroup(MetaModelGroup newMmgroup) {
		MetaModelGroup oldMmgroup = mmgroup;
		mmgroup = newMmgroup;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, GroupmanagementPackage.EMF_REFACTORING_ENTRY__MMGROUP, oldMmgroup, mmgroup));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, GroupmanagementPackage.EMF_REFACTORING_ENTRY__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getAlias() {
		return alias;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAlias(String newAlias) {
		String oldAlias = alias;
		alias = newAlias;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, GroupmanagementPackage.EMF_REFACTORING_ENTRY__ALIAS, oldAlias, alias));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__ID:
				return getId();
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__MMGROUP:
				if (resolve) return getMmgroup();
				return basicGetMmgroup();
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__NAME:
				return getName();
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__ALIAS:
				return getAlias();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__ID:
				setId((String)newValue);
				return;
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__MMGROUP:
				setMmgroup((MetaModelGroup)newValue);
				return;
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__NAME:
				setName((String)newValue);
				return;
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__ALIAS:
				setAlias((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__ID:
				setId(ID_EDEFAULT);
				return;
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__MMGROUP:
				setMmgroup((MetaModelGroup)null);
				return;
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__NAME:
				setName(NAME_EDEFAULT);
				return;
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__ALIAS:
				setAlias(ALIAS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__MMGROUP:
				return mmgroup != null;
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY__ALIAS:
				return ALIAS_EDEFAULT == null ? alias != null : !ALIAS_EDEFAULT.equals(alias);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (id: ");
		result.append(id);
		result.append(", name: ");
		result.append(name);
		result.append(", alias: ");
		result.append(alias);
		result.append(')');
		return result.toString();
	}

} //EmfRefactoringEntryImpl
