/*******************************************************************************
 * Copyright (c) Philipps University of Marburg. All rights reserved. 
 * This program and the accompanying materials are made 
 * available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Philipps University of Marburg - initial API and implementation
 *******************************************************************************/
package org.eclipse.emf.refactor.common.groupmanagement.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.eclipse.emf.refactor.common.groupmanagement.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class GroupmanagementFactoryImpl extends EFactoryImpl implements GroupmanagementFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static GroupmanagementFactory init() {
		try {
			GroupmanagementFactory theGroupmanagementFactory = (GroupmanagementFactory)EPackage.Registry.INSTANCE.getEFactory("http://groupmanagement/1.0"); 
			if (theGroupmanagementFactory != null) {
				return theGroupmanagementFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new GroupmanagementFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GroupmanagementFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case GroupmanagementPackage.GROUP_MANAGEMENT: return createGroupManagement();
			case GroupmanagementPackage.GROUP: return createGroup();
			case GroupmanagementPackage.META_MODEL_GROUP: return createMetaModelGroup();
			case GroupmanagementPackage.EMF_REFACTORING_ENTRY: return createEmfRefactoringEntry();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GroupManagement createGroupManagement() {
		GroupManagementImpl groupManagement = new GroupManagementImpl();
		return groupManagement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Group createGroup() {
		GroupImpl group = new GroupImpl();
		return group;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MetaModelGroup createMetaModelGroup() {
		MetaModelGroupImpl metaModelGroup = new MetaModelGroupImpl();
		return metaModelGroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EmfRefactoringEntry createEmfRefactoringEntry() {
		EmfRefactoringEntryImpl emfRefactoringEntry = new EmfRefactoringEntryImpl();
		return emfRefactoringEntry;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GroupmanagementPackage getGroupmanagementPackage() {
		return (GroupmanagementPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static GroupmanagementPackage getPackage() {
		return GroupmanagementPackage.eINSTANCE;
	}

} //GroupmanagementFactoryImpl
