package org.eclipse.emf.refactor.runtime.ltk.ui;

import org.eclipse.emf.refactor.common.core.IController;
import org.eclipse.emf.refactor.runtime.ltk.ui.wizardpages.EMFRefactorPreviewPage;
import org.eclipse.emf.refactor.runtime.ltk.ui.wizardpages.ModelSmellStatisticsPage;
import org.eclipse.jface.wizard.IWizardPage;

public abstract class AbstractRefactoringWizardWithCustomPreviewPage extends
		AbstractRefactoringWizard {

	private EMFRefactorPreviewPage previewPage = null;
	
	public AbstractRefactoringWizardWithCustomPreviewPage(IController controller) {
		super(controller);
	}

	@Override
	public IWizardPage[] getPages() {
		IWizardPage[] pages = super.getPages();
		for(int i = 0; i < pages.length; i++){
			if((pages[i] instanceof org.eclipse.ltk.internal.ui.refactoring.PreviewWizardPage)
					&& ! (pages[i] instanceof EMFRefactorPreviewPage)){
				if(previewPage == null){
					previewPage = new EMFRefactorPreviewPage();
				}
				pages[i] = previewPage;
			}
		}
		return pages;
	}

	@Override
	public IWizardPage getPage(String name) {
		IWizardPage[] pages = this.getPages();
		for(IWizardPage page : pages){
			if(page.getName().equals(name))
				return page;
		}
		return null;
	}
	
	
	
	

	

}
